// These functions were originally modifications to the LLVM codebase,
// and needed to be isolated to our project.
//===----------------------------------------------------------------------===//
//This software was produced with support from the Defense Advanced
//Research Projects Agency (DARPA) through AFRL Contract FA8650-09-C-1915. 
//Nothing in this work should be construed as reflecting the official policy or
//position of the Defense Department, the United States government, or
//Rice University.
//
//THIS SOFTWARE HAS BEEN APPROVED FOR PUBLIC RELEASE, UNLIMITED DISTRIBUTION.
//
//===----------------------------------------------------------------------===//

#ifndef _COMMON_H_
#define _COMMON_H_

#include "llvm/Target/TargetInstrInfo.h"
#include "llvm/Target/TargetRegisterInfo.h"

namespace llvm {
  
  bool isFPREGKill(const TargetMachine& tm, unsigned opcode);
  
  void initPhysRegClasses(const TargetRegisterInfo* tri);
  
  const TargetRegisterClass *getRegClass_(const TargetRegisterInfo* tri, unsigned RegNo);
  const TargetRegisterClass *getRegClass_(MachineFunction& MF, unsigned RegNo);
    
  /// If sub-registers a and b are valid, then compose them into a register.
  unsigned compose(unsigned a, unsigned b);
  
  /// If the machine instruction is a move instruction, then return true and
  /// set the src and dst registers and sub-registers.
  bool isMoveInstr(const TargetRegisterInfo* TRI, const MachineInstr *MI, unsigned &Src,
                   unsigned &Dst, unsigned &SrcSub, unsigned &DstSub);
  
}

#endif // COMMON_H_
