//===--ConstructRegisterClasses.h - Constructs register classes for reg alloc.=//
// 
// 
// Anshuman Dasgupta and Jason Eckhardt, MSCP, Rice University
//===----------------------------------------------------------------------===//
//===----------------------------------------------------------------------===//
//This software was produced with support from the Defense Advanced
//Research Projects Agency (DARPA) through AFRL Contract FA8650-09-C-1915. 
//Nothing in this work should be construed as reflecting the official policy or
//position of the Defense Department, the United States government, or
//Rice University.
//
//THIS SOFTWARE HAS BEEN APPROVED FOR PUBLIC RELEASE, UNLIMITED DISTRIBUTION.
//
//===----------------------------------------------------------------------===//

#ifndef _CONSTRUCTREGISTERCLASSES_H_
#define _CONSTRUCTREGISTERCLASSES_H_

#include "llvm/Target/TargetRegisterInfo.h"
#include <vector>
#include "llvm/CodeGen/MachineFunction.h"

namespace llvm {
  class ConstructRegisterClasses {

  public: 
    // Holds equivalence classes of TargetRegisterClass'es that do not interfere
    // with each other. One interference graph per entry in the std::vector
    // should be built via BuildInterferenceGraph
    std::vector<std::set<const TargetRegisterClass*> > RegisterClasses;

    ConstructRegisterClasses(const TargetRegisterInfo*, MachineFunction& MF);
  };
}

#endif
