//===----------------------------------------------------------------------===//
//This software was produced with support from the Defense Advanced
//Research Projects Agency (DARPA) through AFRL Contract FA8650-09-C-1915. 
//Nothing in this work should be construed as reflecting the official policy or
//position of the Defense Department, the United States government, or
//Rice University.
//
//THIS SOFTWARE HAS BEEN APPROVED FOR PUBLIC RELEASE, UNLIMITED DISTRIBUTION.
//
//===----------------------------------------------------------------------===//


#ifndef _STATISTICSTRINGMAP_H_
#define _STATISTICSTRINGMAP_H_

#include "llvm/ADT/Statistic.h"
#include <map>
#include <string>

namespace llvm {

  // TODO: Really want hash_map here but its destructor balks 
  // for an unknown reason when called within ~StatisticBase()
  typedef std::map<std::string, unsigned> MapType;

  class StatisticStringMap {
    
  private:
    MapType Value;
    std::string name;
    std::string desc;

  public:
    StatisticStringMap(const char *name, const char *desc) : name(name), desc(desc){
    }

    StatisticStringMap(const MapType &Val, const char *name, const char *desc) {
    }

    ~StatisticStringMap() { 
    }
    
    void increment(std::string index) { ++Value[index]; }
  };

  // Overloading <<
  raw_ostream& operator<< (std::ostream& os,
			    const MapType& MT);
}

#endif
